/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 1.1, Version 1.0, 2000-04-24
****************************************************/

-- Note:
--
-- The statements
--		IF NOT EXISTS (SELECT * 
--			FROM master.dbo.syslogins 
--			WHERE loginname = N'???????')
--
-- have been added to the original code
-- to prevent errors on multiple executions 
-- of the same script, but they don't form part 
-- of the skills-set to learn from this example

 
-- Create a SQL Sever login
-- using English as a default language
-- with Northwind as a default database

IF NOT EXISTS (SELECT * 
	FROM master.dbo.syslogins 
	WHERE loginname = N'Tim')

EXEC sp_addlogin
	  @loginame = 'Tim'
	, @passwd = 'TimPassword'
	, @defdb = 'Northwind'
	, @deflanguage = 'English'

-- Create a SQL Sever login
-- using Spanish as a default language
-- without password, and without default database

IF NOT EXISTS (SELECT * 
	FROM master.dbo.syslogins 
	WHERE loginname = N'Pedro')

EXEC sp_addlogin
	  @loginame = 'Pedro'
	, @deflanguage = 'Spanish'

-- Create a SQL Server login
-- for the local Guest Windows account

IF NOT EXISTS (SELECT * 
	FROM master.dbo.syslogins 
	WHERE loginname = N'BUILTIN\Guest')

EXEC sp_grantlogin 'BUILTIN\Guest'

-- Create a SQL Server login
-- for the domain Guest account

IF NOT EXISTS (SELECT * 
	FROM master.dbo.syslogins 
	WHERE loginname = N'YourDomain\Guest')

EXEC sp_grantlogin 'YourDomain\Guest'

-- Create a SQL Server login
-- for the local group Users Windows account

IF NOT EXISTS (SELECT * 
	FROM master.dbo.syslogins 
	WHERE loginname = N'BUILTIN\Users')

EXEC sp_grantlogin 'BUILTIN\Users'

-- Create a SQL Server login
-- for the domain group Domain Users account

IF NOT EXISTS (SELECT * 
	FROM master.dbo.syslogins 
	WHERE loginname = N'YourDomain\Domain Users')

EXEC sp_grantlogin 'YourDomain\Domain Users'
