/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 1.6, Version 1.0, 2000-04-24
****************************************************/

-- Note:
--
-- The statement:
--
-- IF NOT EXISTS (SELECT * 
--		FROM dbo.sysusers 
--		WHERE name = N'SalesInfo' 
--		AND uid < 16382 
--		AND isapprole = 1)
--
-- has been added to the original code
-- to prevent errors on multiple executions 
-- of the same script, but it doesn't form part 
-- of the skills-set to learn from this example
--
-- However, you cannot execute this script entirely
-- more than once from the same connection
-- because after first execution, 
-- the application role will be active

USE Northwind
GO

-- Create an Application Role

IF NOT EXISTS (SELECT * 
	FROM dbo.sysusers 
	WHERE name = N'SalesInfo' 
	AND uid < 16382 
	AND isapprole = 1)

EXEC sp_addapprole
	  @rolename = 'SalesInfo'
	, @password = 'SIPassword'
GO

-- Change the Application Role password

EXEC sp_approlepassword
	  @rolename = 'SalesInfo'
	, @newpwd = 'NewSIPassword'
GO

-- Drop the Application Role
-- Note: execute this code alone
-- to drop the SalesInfo application role

/*

EXEC sp_dropapprole 'SalesInfo'

*/

-- Activate the Appliction role
-- with encryption

EXEC sp_setapprole
	  @rolename = 'SalesInfo'
	, @password = {Encrypt N 'NewSIPassword'}
	, @encrypt = 'ODBC'

-- Activate the Appliction role
-- without encryption
-- Note: execute this conde instead of
-- the preceding statement
-- if you do not want to use encryption

/*

EXEC sp_setapprole
@rolename = 'SalesInfo'
, @password = 'NewSIPassword'

*/
