/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 4.12, Version 1.0, 2001-04-01
****************************************************/

USE Northwind

-- Returns all employees whose last name begins with 'b'
SELECT lastname, firstname
FROM Employees
WHERE lastname LIKE 'b%'

-- Returns all employees who don't live in Seattle, Redmond or Tacoma
SELECT lastname, firstname, city
FROM Employees
WHERE city NOT IN ('seattle','redmond','tacoma')

-- Returns all employees that were hired between 1/1/1993 and 12/31/1993
SELECT lastname, firstname, hiredate
FROM Employees
WHERE hiredate BETWEEN '1993.1.1' AND '1993.12.31'

-- Returns all employees that live in any other city than London
SELECT lastname, firstname, city
FROM Employees
WHERE city <> 'london'
GO

