/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 6.32, Version 1.0, 2001-04-24
****************************************************/

USE Northwind
GO

-- To retrieve number of index levels

SELECT INDEXPROPERTY(OBJECT_ID('Products'), 'PK_Products', 'IndexDepth') 
AS 'Index Levels'

-- To determine if the index is clustered

SELECT CASE 
INDEXPROPERTY(OBJECT_ID('Products'), 'PK_Products', 'IsClustered')
WHEN 0 THEN 'No'
ELSE 'Yes' END as 'Is Clustered'

-- To determine if i is not a real index
-- So it cannot be used for data access
-- because it contains only statistics

SELECT CASE 
INDEXPROPERTY(OBJECT_ID('Products'), 'PK_Products', 'IsStatistics')
WHEN 0 THEN 'No'
ELSE 'Yes' END as 'Is Statistics only'

-- To know if the index is unique

SELECT CASE 
INDEXPROPERTY(OBJECT_ID('Products'), 'PK_Products', 'IsUnique')
WHEN 0 THEN 'No'
ELSE 'Yes' END as 'Is Unique'
