/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 6.34, Version 1.0, 2001-04-24
****************************************************/

USE Northwind
GO

-- Create the view

CREATE VIEW Customers_UK
WITH SCHEMABINDING
AS
	SELECT CustomerID
		, CompanyName
		, ContactName
		, Phone
	FROM dbo.Customers
	WHERE Country = 'UK'
GO

-- Test how a normal query uses the view

SELECT CustomerID
	, CompanyName
	, ContactName
	, Phone
FROM Customers
WHERE Country = 'UK'
	AND CompanyName like 'C%'
GO

-- Create a clustered index on the view

CREATE UNIQUE CLUSTERED INDEX CustUK 
ON Customers_UK (CustomerID)

-- Create a nonclustered index on the CompanyName field on the view

CREATE NONCLUSTERED INDEX CustUKCompany 
ON Customers_UK (CompanyName)
GO

-- Test how a normal query uses the view after indexing the view

SELECT CustomerID
	, CompanyName
	, ContactName
	, Phone
FROM Customers
WHERE Country = 'UK'
	AND CompanyName like 'C%'
