/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 6.36, Version 1.0, 2001-04-24
****************************************************/

/* Created by: Index Tuning Wizard     */
/* Date: 25/10/2000             */
/* Time: 23:36:33             */
/* Server Name: BYEXAMPLE             */
/* Database Name: Northwind             */

USE [Northwind]
go

SET QUOTED_IDENTIFIER ON
SET ARITHABORT ON
SET CONCAT_NULL_YIELDS_NULL ON
SET ANSI_NULLS ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
SET NUMERIC_ROUNDABORT OFF
go

DECLARE @bErrors as bit

BEGIN TRANSACTION
SET @bErrors = 0

DROP INDEX [dbo].[Orders].[ShipPostalCode]
DROP INDEX [dbo].[Orders].[ShippedDate]
DROP INDEX [dbo].[Orders].[CustomersOrders]
DROP INDEX [dbo].[Orders].[OrderDate]
DROP INDEX [dbo].[Orders].[CustomerID]
DROP INDEX [dbo].[Orders].[ShippersOrders]
DROP INDEX [dbo].[Orders].[EmployeesOrders]
DROP INDEX [dbo].[Orders].[EmployeeID]
CREATE NONCLUSTERED INDEX [Orders7]
ON [dbo].[Orders] ([OrderID] ASC, [CustomerID] ASC, [OrderDate] ASC )

IF( @@error <> 0 ) SET @bErrors = 1

IF( @bErrors = 0 )
COMMIT TRANSACTION
ELSE
ROLLBACK TRANSACTION

BEGIN TRANSACTION
SET @bErrors = 0

DROP INDEX [dbo].[Order Details].[ProductID]
DROP INDEX [dbo].[Order Details].[orderID]
DROP INDEX [dbo].[Order Details].[price]
DROP INDEX [dbo].[Order Details].[OrdersOrder_Details]
DROP INDEX [dbo].[Order Details].[ProductsOrder_Details]
DROP INDEX [dbo].[Order Details].[ndxSale]

IF( @bErrors = 0 )
COMMIT TRANSACTION
ELSE
ROLLBACK TRANSACTION

BEGIN TRANSACTION
SET @bErrors = 0

DROP INDEX [dbo].[Customers].[Region]
DROP INDEX [dbo].[Customers].[CompanyName]
DROP INDEX [dbo].[Customers].[Contact]
DROP INDEX [dbo].[Customers].[ndx_Customers_City]
DROP INDEX [dbo].[Customers].[PostalCode]
DROP INDEX [dbo].[Customers].[City]

IF( @bErrors = 0 )
COMMIT TRANSACTION
ELSE
ROLLBACK TRANSACTION

BEGIN TRANSACTION
SET @bErrors = 0

DROP INDEX [dbo].[Products].[C_Products_Category_Price]
DROP INDEX [dbo].[Products].[CategoriesProducts]
DROP INDEX [dbo].[Products].[SuppliersProducts]
DROP INDEX [dbo].[Products].[CategoryID]
DROP INDEX [dbo].[Products].[ProductName]
DROP INDEX [dbo].[Products].[SupplierID]

IF( @bErrors = 0 )
COMMIT TRANSACTION
ELSE
ROLLBACK TRANSACTION


/* Statistics to support recommendations */

CREATE STATISTICS [hind_325576198_1A_2A_3A_4A_5A]
ON [dbo].[order details] ([OrderID], [ProductID], [UnitPice], [Quantity], [Discount])
