/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 7.1, Version 1.0, 2001-04-24
****************************************************/

-- Define a PRIMARY KEY in a single column
-- using the DEFAULT constraint name

CREATE TABLE NewRegions (
	RegionID int NOT NULL
		PRIMARY KEY NONCLUSTERED
	, RegionDescription nchar (50) NOT NULL
)
GO

DROP TABLE NewRegions
GO

-- Define a PRIMARY KEY in a single column
-- specifying the constraint name

CREATE TABLE NewRegions (
	RegionID int NOT NULL
		CONSTRAINT PK_NewRegions
		PRIMARY KEY NONCLUSTERED
	, RegionDescription nchar (50) NOT NULL
)
GO

DROP TABLE NewRegions
GO

-- Define a PRIMARY KEY in a single column
-- specifying the constraint name
-- and defining the constraint at table level

CREATE TABLE NewRegions (
	RegionID int NOT NULL
	, RegionDescription nchar (50) NOT NULL 
	, CONSTRAINT PK_NewRegions
		PRIMARY KEY NONCLUSTERED (RegionID)
)
GO

DROP TABLE NewRegions
GO

-- Define a PRIMARY KEY in a single column
-- specifying the constraint name
-- and defining the constraint at table level
-- using the ALTER TABLE statement

CREATE TABLE NewRegions (
	RegionID int NOT NULL
	, RegionDescription nchar (50) NOT NULL
)
GO

ALTER TABLE NewRegions
ADD CONSTRAINT PK_NewRegions
	PRIMARY KEY NONCLUSTERED (RegionID)
GO

DROP TABLE NewRegions
GO
