/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 7.6, Version 1.0, 2001-04-24
****************************************************/

-- Define a composite UNIQUE in two columns
-- specifying the constraint name


CREATE TABLE ProductSales (
	ProductID int NOT NULL
	, SaleID int NOT NULL
	, Quantity int NOT NULL
	, Price money NOT NULL
	, Description varchar(200) NULL
	, CONSTRAINT UC_ProductSales
		UNIQUE NONCLUSTERED (ProductID, SaleID)
)
GO

DROP TABLE ProductSales
GO

-- Define a composite UNIQUE constraint in two columns
-- using the ALTER TABLE statement


CREATE TABLE ProductSales (
	ProductID int NOT NULL
	, SaleID int NOT NULL
	, Quantity int NOT NULL
	, Price money NOT NULL
	, Description varchar(200) NULL
)

ALTER TABLE ProductSales
ADD CONSTRAINT UC_ProductSales
	UNIQUE NONCLUSTERED (ProductID, SaleID)
GO

DROP TABLE ProductSales
GO
