/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 7.8, Version 1.0, 2001-04-24
****************************************************/

-- Define a CHECK constraint in a single column
-- specifying the constraint name
-- and defining the constraint at table level

CREATE TABLE NewProducts (
	ProductID int NOT NULL
	, ProductName varchar(50) NOT NULL
	, UnitPrice money NOT NULL 
	, CONSTRAINT CC_Prod_Name
		CHECK (ProductName <> '')
)
GO

DROP TABLE NewProducts
GO

-- Define a CHECK constraint in a single column
-- specifying the constraint name
-- and defining the constraint at table level
-- as an expression

CREATE TABLE NewOrders (
	OrderID int NOT NULL
	, CustomerID int NOT NULL
	, SaleDate smalldatetime NOT NULL 
	, DueDate smalldatetime NOT NULL
	, CONSTRAINT CC_Order_DueDate
		CHECK (DATEDIFF(day, SaleDate, DueDate) <= 90)
)
GO

DROP TABLE NewOrders
GO

-- Define a CHECK constraint in a single column
-- specifying the constraint name
-- and defining the constraint at table level
-- as a multiple expressions linked by
-- logical operators

CREATE TABLE NewOrders (
	OrderID int NOT NULL
	, CustomerID int NOT NULL
	, SaleDate smalldatetime NOT NULL 
	, DueDate smalldatetime NOT NULL
	, ShipmentMethod char(1) NOT NULL
	, CONSTRAINT CC_Order_DueDate
		CHECK	((DATEDIFF(day, SaleDate, DueDate) <= 90)
			AND (DATEDIFF(day, CURRENT_TIMESTAMP, SaleDate) <= 0)
			AND (ShipmentMethod IN ('A', 'L', 'S'))
			)
)
GO

DROP TABLE NewOrders
GO
