/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 7.9, Version 1.0, 2001-04-24
****************************************************/

-- Define multiple CHECK constraint
-- in existing tables specifying
-- the constraint name and defining
-- the constraint at table level
-- using the ALTER TABLE statement
-- checking existing data

CREATE TABLE NewOrders (
	OrderID int NOT NULL
	, CustomerID int NOT NULL
	, SaleDate smalldatetime NOT NULL 
	, DueDate smalldatetime NOT NULL
	, ShipmentMethod char(1) NOT NULL
)

ALTER TABLE NewOrders
ADD CONSTRAINT CC_Order_DueDate
	CHECK (DATEDIFF(day, SaleDate, DueDate) <= 90)

ALTER TABLE NewOrders
ADD CONSTRAINT CC_Order_SaleDate
	CHECK (DATEDIFF(day, CURRENT_TIMESTAMP, SaleDate) <= 0)

ALTER TABLE NewOrders
ADD CONSTRAINT CC_Order_Shipment
	CHECK (ShipmentMethod IN ('A', 'L', 'S'))

GO

DROP TABLE NewOrders
GO

-- Define multiple CHECK constraint
-- in existing tables specifying
-- the constraint name and defining
-- the constraint at table level
-- using the ALTER TABLE statement
-- checking existing data
-- only for one of the constraints

CREATE TABLE NewOrders (
	OrderID int NOT NULL
	, CustomerID int NOT NULL
	, SaleDate smalldatetime NOT NULL 
	, DueDate smalldatetime NOT NULL
	, ShipmentMethod char(1) NOT NULL
)

ALTER TABLE NewOrders
WITH NOCHECK
ADD CONSTRAINT CC_Order_DueDate
	CHECK (DATEDIFF(day, SaleDate, DueDate) <= 90)

ALTER TABLE NewOrders
ADD CONSTRAINT CC_Order_SaleDate
	CHECK (DATEDIFF(day, CURRENT_TIMESTAMP, SaleDate) <= 0)

ALTER TABLE NewOrders
WITH NOCHECK
ADD CONSTRAINT CC_Order_Shipment
	CHECK (ShipmentMethod IN ('A', 'L', 'S'))

GO

DROP TABLE NewOrders
GO
