/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 7.16, Version 1.0, 2001-04-24
****************************************************/

-- Create Customers and Orders tables

CREATE TABLE Customers(
	  CustomerID int
		PRIMARY KEY
	, CustomerName varchar(20) NOT NULL)

CREATE TABLE Orders(
	  OrderID int
		IDENTITY(1,1)
		PRIMARY KEY
	, CustomerID int NOT NULL
	, OrderDate smalldatetime NOT NULL
		DEFAULT CURRENT_TIMESTAMP
)
GO

-- Create the FOREIGN KEY constraint

ALTER TABLE Orders
ADD CONSTRAINT FK_Orders
	FOREIGN KEY (CustomerID)
	REFERENCES Customers (CustomerID)
GO

/*

-- Or you could define the Orders
-- table with References
-- without using the ALTER TABLE
-- statement to define the FOREIGN KEY

CREATE TABLE Orders(
	  OrderID int
		IDENTITY(1,1)
		PRIMARY KEY
	, CustomerID int NOT NULL
		REFERENCES Customers(CustomerID)
	, OrderDate smalldatetime NOT NULL
		DEFAULT CURRENT_TIMESTAMP
)
--GO

*/


-- Insert some Customers

INSERT Customers
VALUES (1, 'MyComp corp.')

INSERT Customers
VALUES (2, 'ACME Inc.')

INSERT Customers
VALUES (3, 'NewDotCompany Ltd.')

-- Insert some Orders
-- with the default Date

INSERT Orders (CustomerID)
VALUES (1)

INSERT Orders (CustomerID)
VALUES (2)

INSERT Orders (CustomerID)
VALUES (3)

INSERT Orders (CustomerID)
VALUES (3)

-- Try to update customer 3 PRIMARY KEY
-- to a different value

PRINT CHAR(10) + 'Trying to update a customer PK' + CHAR(10)

UPDATE Customers
SET CustomerID = 30
WHERE CustomerID = 3

-- Try to insert a new order for a
-- nonexisting customer

PRINT CHAR(10) + 'Trying to insert an orphan Order' + CHAR(10)

INSERT Orders (CustomerID)
VALUES (10)

GO

DROP TABLE Orders

DROP TABLE Customers
