/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 7.18, Version 1.0, 2001-04-24
****************************************************/

USE Tempdb
GO

-- Create Customers and Orders tables

CREATE TABLE Customers(
	  CustomerID int
		PRIMARY KEY
	, CustomerName varchar(20) NOT NULL
)

CREATE TABLE Orders(
	  OrderID int
		IDENTITY(1,1)
		PRIMARY KEY
	, CustomerID int NOT NULL
	, OrderDate smalldatetime NOT NULL
		DEFAULT CURRENT_TIMESTAMP
)
GO

-- Create the FOREIGN KEY constraint
-- with CASCADE

ALTER TABLE Orders
ADD CONSTRAINT FK_Orders
	FOREIGN KEY (CustomerID)
	REFERENCES Customers (CustomerID)
	ON DELETE CASCADE -- This is optional
	ON UPDATE CASCADE
GO

-- Insert some Customers

INSERT Customers
VALUES (1, 'MyComp corp.')

INSERT Customers
VALUES (2, 'ACME Inc.')

INSERT Customers
VALUES (3, 'NewDotCompany Ltd.')

-- Insert some Orders
-- with the default Date

INSERT Orders (CustomerID)
VALUES (1)

INSERT Orders (CustomerID)
VALUES (1)

INSERT Orders (CustomerID)
VALUES (2)

INSERT Orders (CustomerID)
VALUES (2)

INSERT Orders (CustomerID)
VALUES (2)

INSERT Orders (CustomerID)
VALUES (3)

INSERT Orders (CustomerID)
VALUES (3)

-- Show the data

PRINT CHAR(10) + 'Original Customers table' + CHAR(10)

SELECT *
FROM Customers

PRINT CHAR(10) + 'Original Orders table' + CHAR(10)

SELECT *
FROM Orders

GO

-- Update Curtomer 3
-- Change CustomerID from 3 for 30

UPDATE Customers
SET CustomerID = 30
WHERE CustomerID = 3

PRINT CHAR(10) + 'Customers table after update Customer 3' + CHAR(10)

SELECT *
FROM Customers

PRINT CHAR(10) + 'Orders table after update Customer 3' + CHAR(10)

SELECT *
FROM Orders

GO

DROP TABLE Orders

DROP TABLE Customers
