/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 8.27, Version 1.0, 2001-04-01
****************************************************/

USE Northwind
GO

CREATE PROC dbo.CheckSupplier
@supplier_name VARCHAR(40)
AS

PRINT '3) The nesting level is ' + CAST(@@nestlevel AS VARCHAR(5))

IF EXISTS (SELECT * FROM Suppliers WHERE companyname = @supplier_name)
    RETURN -1
ELSE
    RETURN 0
GO

CREATE PROC dbo.InsertSupplier
@suppliername NVARCHAR(40),
@contactname NVARCHAR(30),
@contacttitle NVARCHAR(30)
AS
DECLARE @supplier_exists INT
PRINT '2) The nesting level is ' + CAST(@@nestlevel AS VARCHAR(5))
EXEC @supplier_exists = CheckSupplier @suppliername
PRINT '4) The nesting level is ' + CAST(@@nestlevel AS VARCHAR(5))
IF @supplier_exists = 0
    INSERT INTO dbo.Suppliers (companyname,contactname,contacttitle)
    VALUES (@suppliername,@contactname,@contacttitle)
ELSE
    PRINT 'This supplier already exists in the database'
GO

PRINT '1) The nesting level is ' + CAST(@@nestlevel AS VARCHAR(5))
EXEC InsertSupplier 'ACME','Fernando Guerrero','Owner'
PRINT '5) The nesting level is ' + CAST(@@nestlevel AS VARCHAR(5))
GO

