/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 9.4, Version 1.0, 2001-04-24
****************************************************/

USE Northwind
GO

-- Create the view

CREATE VIEW TotalSalesByCategory
AS
	SELECT P.CategoryID
		, C.CategoryName
		, SUM(OD.UnitPrice * Quantity * (1 - Discount)) as Total
	FROM [Order Details] OD
		JOIN Products P
			ON P.ProductID = OD.ProductID
		JOIN Categories C
			ON C.CategoryID = P.CategoryID
	GROUP BY P.CategoryID, C.categoryName
GO

-- Use the view to search
-- for 'Confections' totals

SELECT *
FROM TotalSalesByCategory
WHERE CategoryName = 'Confections'
