/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 9.13, Version 1.0, 2001-04-24
****************************************************/

-- Note: this is code is not supposed to be executed

-- Create a trigger on the customer table
-- to track INSERT, UPDATE and DELETE actions

CREATE TRIGGER tr_Customers
ON Customers
AFTER INSERT, UPDATE, DELETE
AS
-- Your code here
GO

-- Create a trigger on the customer table
-- to track INSERT, UPDATE and DELETE actions
-- Using the FOR keyword

CREATE TRIGGER tr_Customers
ON Customers
FOR INSERT, UPDATE, DELETE
AS
-- Your code here
GO

-- Create a trigger on the customer table
-- to track INSERT actions

CREATE TRIGGER isr_Customers
ON Customers
AFTER INSERT
AS
-- Your code here
GO

-- Create a trigger on the customer table
-- to track INSERT, UPDATE and DELETE actions
-- With encryption

CREATE TRIGGER tr_Customers
ON Customers
WITH ENCRYPTION
AFTER INSERT, UPDATE, DELETE
AS
-- Your code here
GO

-- Create a trigger on the customer table
-- to track INSERT, UPDATE and DELETE actions
-- Preventing its execution when receiving
-- replicate data

CREATE TRIGGER tr_Customers
ON Customers
AFTER INSERT, UPDATE, DELETE
NOT FOR REPLICATION
AS
-- Your code here
GO

-- Create an INSTEAD OF trigger
-- on the NewCustomers view
-- to execute on attempts to modify data through the view

CREATE TRIGGER iotr_NewCustomers
ON NewCustomers
INSTEAD OF INSERT, UPDATE, DELETE
AS
-- Your code here
GO

-- Create an INSTEAD OF INSERT trigger
-- on the NewCustomers view
-- to execute on attempts to insert data through the view

CREATE TRIGGER iotr_NewCustomers
ON NewCustomers
INSTEAD OF INSERT
AS
-- Your code here
GO
