/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 9.15, Version 1.0, 2001-04-24
****************************************************/

USE Northwind
GO

CREATE TRIGGER tr_OrderDetails
ON [Order Details]
AFTER UPDATE
AS
	-- Testing for changes to the PRIMARY KEY
	IF UPDATE(OrderID)
	BEGIN
		PRINT 'Changes to the PRIMARY KEY are not allowed'
		ROLLBACK TRAN
	END
	
	-- Testing for changes on the 2nd, 3rd and 5th columns
	IF ((COLUMNS_UPDATED() & (2 + 4 + 8)) > 0)
	BEGIN
		IF ((COLUMNS_UPDATED() & 2) = 2)
			PRINT 'ProductID updated'
		IF ((COLUMNS_UPDATED() & 4) = 4)
			PRINT 'UnitPrice updated'
		IF ((COLUMNS_UPDATED() & 8) = 8)
			PRINT 'Quantity updated'
	END
GO

PRINT CHAR(10) + 'Updating ProductID and UnitPrice'

UPDATE [Order Details]
SET ProductID = ProductID
	, UnitPrice = UnitPrice

PRINT CHAR(10) + 'Updating Quantity only'

UPDATE [Order Details]
SET Quantity = Quantity

PRINT CHAR(10) + 'Updating OrderID'

UPDATE [Order Details]
SET OrderID = OrderID
