/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 10.5, Version 1.0, 2001-04-25
****************************************************/

USE Northwind
GO

-- Create a base function to extract a three-digits
-- number based on the scrambled version of the
-- milliseconds information of the latest executed
-- statement in SQL Server

CREATE FUNCTION dbo.Get3Rand
()
RETURNS int
AS
BEGIN
	DECLARE @dt datetime
	DECLARE @dts varchar(3)
	
	SET @dt = (
		SELECT MAX(last_batch)
		FROM master.dbo.sysprocesses
		)
	
	SET @dts = RIGHT(CONVERT(varchar(20), @dt, 114) , 3)
	
	RETURN CAST(SUBSTRING(@dts, 2, 1)
		+ RIGHT(@dts, 1)
		+ LEFT(@dts, 1) AS int)
	
END
GO

-- Create the new NewPRand Random function
-- based on the Get3Rand function

CREATE FUNCTION dbo.NewPRand
()
RETURNS float
AS
BEGIN
	DECLARE @r float
	
	SET @r = '0' 
		+ LEFT(RIGHT(CONVERT(varchar(40),
			dbo.Get3Rand() * dbo.Get3Rand() / pi(), 2), 21), 16)
	
	RETURN (@r)
END
