/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 10.6, Version 1.0, 2001-04-25
****************************************************/

USE Northwind
GO

CREATE FUNCTION dbo.MediumProductUnitPrice
()
RETURNS money
AS
BEGIN

	-- Create hosting table variable
	
	DECLARE @t TABLE(
		  id int identity(1,1)
		, UnitPrice money)
	
	-- Inserts the product prices in ascending order
	
	INSERT INTO @t (UnitPrice)
	SELECT UnitPrice
	FROM Products
	ORDER BY UnitPrice ASC
	
	-- Selects the medium price
	
	RETURN (
		SELECT MAX(UnitPrice)
		FROM @t
		WHERE ID <=
			(
				SELECT MAX(ID)
				FROM @t
			) / 2
		)
	
END
