/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation
** Source code. Listing 10.9, Version 1.0, 2001-04-25
****************************************************/

SELECT dbo.MaxProductID()
GO

SELECT ProductID, dbo.MaxProductID() AS 'MaxID'
FROM Products
GO

UPDATE [Order Details]
SET ProductID = dbo.MaxProductID()
WHERE ProductID = 25
GO

SELECT ProductID, MaxID
FROM Products
	CROSS JOIN (SELECT dbo.MaxProductID() AS 'MaxID') AS MI
GO

SELECT P.ProductID, Quantity
FROM Products AS P
	JOIN [Order Details] AS OD
		ON P.ProductID = OD.ProductID
		AND P.ProductID = dbo.MaxProductID()
GO

SELECT P.ProductID, Quantity
FROM Products AS P
	JOIN [Order Details] AS OD
		ON P.ProductID = OD.ProductID
WHERE P.ProductID = dbo.MaxProductID()
GO

SELECT P.ProductID, SUM(Quantity)
FROM Products AS P
	JOIN [Order Details] AS OD
		ON P.ProductID = OD.ProductID
GROUP BY P.ProductID
HAVING P.ProductID = dbo.MaxProductID()
GO

SELECT ProductID, ProductName,
	CASE ProductID
		WHEN dbo.MaxProductID() THEN 'Last Product'
		ELSE '' 
	END AS Note
FROM Products
GO

DECLARE @ID int

SET @ID = dbo.MaxProductID()
