/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 10.16, Version 1.0, 2001-04-04
****************************************************/

USE Northwind
GO

PRINT CHAR(10) 
	+ 'Use GetCustomersFromCountry(''Mexico'')' 
	+ CHAR(10)

SELECT CustomerID, CompanyName, City
FROM dbo.GetCustomersFromCountry('Mexico')

PRINT CHAR(10) + 'Use GetCustomersFromUSA()' + CHAR(10)

Select CustomerID, CompanyName, City
FROM dbo.GetCustomersFromUSA()

PRINT CHAR(10)
	+ 'Use GetCustomersFromCountry(''Mexico'') with the IN operator'
	+ CHAR(10)

SELECT OrderID
	, CONVERT(varchar(10), OrderDate, 120) AS OrderDate
FROM Orders
WHERE CustomerID IN
	(
	SELECT CustomerID
	FROM dbo.GetCustomersFromCountry('Mexico')
	)

PRINT CHAR(10)
	+ 'Joins OrdersByValue to Customers'
	+ CHAR(10)

SELECT CompanyName
	, OrderID
	, TotalValue
	, CONVERT(varchar(10), OrderDate, 120) AS OrderDate
FROM dbo.OrdersByValue(10000) AS OBV
	JOIN Customers C
		ON OBV.CustomerID = C.CustomerID


PRINT CHAR(10)
	+ 'Joins TopTenOrders to Customers'
	+ CHAR(10)

SELECT CompanyName
	, OrderID
	, TotalValue
	, CONVERT(varchar(10), OrderDate, 120) AS OrderDate
FROM dbo.TopTenOrders() AS OBV
JOIN Customers C
	ON OBV.CustomerID = C.CustomerID
