/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 10.22, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

IF OBJECT_ID('GetCustomers') IS NOT NULL
	DROP FUNCTION GetCustomers
GO

IF OBJECT_ID('NewCustomers') IS NOT NULL
	DROP TABLE NewCustomers
GO

SELECT *
INTO NewCustomers
FROM Customers
GO

CREATE  FUNCTION dbo.GetCustomers()
RETURNS @List TABLE
	(CustomerID nchar(5)
	, CompanyName nvarchar(40))
AS
BEGIN

	INSERT @List
		SELECT CustomerID, CompanyName
		FROM NewCustomers
	
	RETURN
END
GO

ALTER TABLE NewCustomers
DROP COLUMN CompanyName

PRINT CHAR(10)
	+ 'ALTER TABLE statement sucessful without SCHEMABINDING'
	+ CHAR(10)
GO

SELECT *
FROM GetCustomers()
GO

PRINT CHAR(10)
	+ 'Execution of the GetCustomers table was unsucessful'
	+ CHAR(10)
	+ 'because it references a non-existing field'
	+ CHAR(10)
GO

IF OBJECT_ID('GetCustomers') IS NOT NULL
	DROP FUNCTION GetCustomers
GO

IF OBJECT_ID('NewCustomers') IS NOT NULL
	DROP TABLE NewCustomers
GO

SELECT *
INTO NewCustomers
FROM Customers
GO


CREATE  FUNCTION dbo.GetCustomers()
RETURNS @List TABLE
	(CustomerID nchar(5)
	, CompanyName nvarchar(40))
WITH SCHEMABINDING
AS
BEGIN

	INSERT @List
		SELECT CustomerID, CompanyName
		FROM NewCustomers
	
	RETURN
END
GO

PRINT CHAR(10)
	+ 'CREATE FUNCTION failed with SCHEMABINDING'
	+ CHAR(10)
	+ 'because it did not use two part names'
	+ CHAR(10)
GO

CREATE  FUNCTION dbo.GetCustomers()
RETURNS @List TABLE
	(CustomerID nchar(5)
	, CompanyName nvarchar(40))
WITH SCHEMABINDING
AS
BEGIN

	INSERT @List
		SELECT CustomerID, CompanyName
		FROM dbo.NewCustomers
	
	RETURN
END
GO

PRINT CHAR(10)
	+ 'CREATE FUNCTION was sucessful with SCHEMABINDING'
	+ CHAR(10)
	+ 'because it did use two part names'
	+ CHAR(10)
GO

ALTER TABLE NewCustomers
DROP COLUMN CompanyName
GO

PRINT CHAR(10)
	+ 'ALTER TABLE statement failed with SCHEMABINDING'
	+ CHAR(10)
GO
