/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 10.26, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

CREATE VIEW vw_TopTenOrders
AS

	SELECT TOP 10 WITH TIES
		O.OrderID, CustomerID, OrderDate, TotalValue
	FROM Orders O
		JOIN (
			SELECT OrderID
				, SUM(dbo.TotalPrice(Quantity, UnitPrice, Discount)) AS TotalValue
			FROM [Order Details]
			GROUP BY OrderID
		) AS OD
			ON O.OrderID = OD.OrderID
	ORDER BY TotalValue DESC

GO

SELECT *
FROM tv_TopTenOrders()
GO

SELECT *
FROM vw_TopTenOrders
GO
