/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 11.5, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

SET NOCOUNT ON
GO

-- Get the medium unit price

SELECT (
	MIN(UnitPrice) +
	MAX(UnitPrice)
	)/2 AS NewPrice
FROM Products

-- Selects three constants

SELECT 1, 2, 3
GO

-- Retrieve one single row with the Maximum and Average UnitPrice

SELECT AVG(Unitprice) as AvgPrice,
	MAX(Unitprice) as MaxPrice
FROM Products

GO

-- Compare the UnitPrice of every product
-- with the Average UnitPrice

DECLARE @UP money

SELECT @UP = AVG(Unitprice)
FROM Products

SELECT ProductName, UnitPrice, @UP AS AvgPrice
FROM Products
WHERE CategoryID = 2
GO

-- Updates the UnitPrice of the product 11 to 
-- 20% more than the maximum UnitPrice.

DECLARE @UP money

SELECT @UP = MAX(Unitprice)
FROM Products

UPDATE Products
SET UnitPrice = @UP * 1.2
WHERE ProductID = 11

-- You want to show the product with maximum UnitPrice

DECLARE @UP money

SELECT @UP = MAX(Unitprice)
FROM Products

SELECT ProductName, UnitPrice
FROM Products P
WHERE Unitprice = @UP

-- You want to retrieve the Categories with average Unitprice 
-- greater than the overall products average price

DECLARE @UP money

SELECT @UP = AVG(Unitprice)
FROM Products

SELECT CategoryID, AVG(UnitPrice)
FROM Products P
GROUP BY CategoryID
HAVING AVG(UnitPrice) > @UP
