/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 11.7, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

SET NOCOUNT ON
GO

-- Orders placed by clients from London
-- and EmployeeID = 1

SELECT O.OrderID, O.CustomerID, O.EmployeeID, O.OrderDate
FROM Orders O
	JOIN Customers C
		ON O.CustomerID = C.CustomerID
WHERE City = 'London'
	AND EmployeeID = 1

-- Select all the products with the UnitPrice 
-- greater than all the products from Category 2

DECLARE @MP money

SELECT @MP = MAX(Unitprice)
FROM Products
WHERE CategoryID = 2

SELECT ProductID, ProductName, UnitPrice
FROM Products
WHERE UnitPrice > @MP

-- Select all the order details related to products from category 2
-- and OrderID between 10250 and 10300

SELECT OD.OrderID, OD.ProductID, OD.UnitPrice
FROM [Order Details] OD
	JOIN Products P
		ON P.ProductID = OD.ProductID
WHERE CategoryID = 2
	AND OrderID BETWEEN 10250 AND 10300

-- List all the products only if there are any products never ordered

DECLARE @n int

SELECT @n = COUNT(*)
FROM Products
	LEFT OUTER JOIN [Order Details]
		ON Products.ProductID = [Order Details].ProductID
WHERE [Order Details].ProductID IS NULL

SELECT ProductID, ProductName
FROM Products
WHERE ISNULL(@n, 0) > 0

-- OR

IF EXISTS(
		SELECT Products.ProductID
		FROM Products
			LEFT OUTER JOIN [Order Details]
				ON Products.ProductID = [Order Details].ProductID
		WHERE [Order Details].ProductID IS NULL
	)
	SELECT ProductID, ProductName
	FROM Products
