/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 11.9, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

-- Show name of product and category for products of categories 1 to 3

SELECT CategoryName, ProductName
FROM Products P
	JOIN Categories AS C
		ON C.CategoryID = P.CategoryID
WHERE P.CategoryID BETWEEN 1 AND 3
	AND ProductName LIKE 'L%'

-- Show if we have beverage sales
-- Note: CASE will be explained later in this chapter

DECLARE @N int

SELECT @N = COUNT(*)
FROM [Order details] O
	JOIN Products P
		ON O.ProductID = P.ProductID
WHERE P.CategoryID = 1

SELECT 
	CASE
		WHEN ISNULL(@n, 0) > 0
			THEN  'We do have beverage Sales'
		ELSE 'We do not have any beverage Sales'
	END
AS [Beverage Sales]
