/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 11.12, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

SET NOCOUNT ON
GO

-- Select the target UnitPrice, the minimum, average,
-- and maximum selling price for every product
-- show non-ordered products as well

-- With a Correlated Subquery

SELECT ProductID
	, UnitPrice
	, (
			SELECT AVG(UnitPrice)
			FROM [Order Details]
			WHERE [Order Details].ProductID =
			Products.ProductID
		) AS AvgPrice
	, (
			SELECT MIN(UnitPrice)
			FROM [Order Details]
			WHERE [Order Details].ProductID =
			Products.ProductID
		) AS MaxPrice
	, ProductName
FROM Products
WHERE CategoryID = 1

-- With a standard (non-correlated) subquery

SELECT P.ProductID
	, P.UnitPrice
	, MMP.AvgPrice
	, MMP.MinPrice
	, P.ProductName
FROM Products P
	LEFT OUTER JOIN (
			SELECT ProductID
				, MIN(UnitPrice) AS MinPrice
				, AVG(UnitPrice) AS AvgPrice
			FROM [Order Details]
			GROUP BY ProductID
		) AS MMP
		ON MMP.ProductID = P.ProductID
WHERE CategoryID = 1

-- Without subqueries

SELECT P.ProductID
	, P.UnitPrice
	, AVG(OD.UnitPrice) AS AvgPrice
	, MIN(OD.UnitPrice) AS MinPrice
	, P.ProductName
FROM Products P
	LEFT OUTER JOIN [Order Details] OD
		ON OD.ProductID = P.ProductID
WHERE CategoryID = 1
GROUP BY P.productID, P.UnitPrice, P.ProductName
