/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 11.15, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

SET NOCOUNT ON
GO

-- Using a Derived Table to compare UnitPrice 
-- with the actual minimum and maximum prices

SELECT P.ProductID
	, P.UnitPrice
	, (MinPrice + MaxPrice) / 2 AS MediumPrice
FROM Products P
	JOIN (
			SELECT ProductID
				, MIN(UnitPrice) as MinPrice
				, MAX(UnitPrice) as Maxprice
			FROM [Order Details]
			GROUP BY ProductID
		) AS OD
		ON OD.ProductID = P.ProductID

-- Using a Derived Table to produce a discounted price list

SELECT P.ProductID
	, Discount * 100 AS Discount
	, P.UnitPrice * (1 - Discount) as Price
FROM Products P
	CROSS JOIN (
			SELECT 0.0 AS Discount
		UNION ALL
			SELECT 0.10
		UNION ALL
			SELECT 0.20
		UNION ALL
			SELECT 0.30
		) AS OD
