/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 11.19, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

SET NOCOUNT ON
GO

-- Retrieve Price and discount from Order details 
-- plus Category, product and customer
-- and show the Price subtotal per Category

SELECT CategoryName AS Category
	, ProductName AS Product
	, CompanyName AS Customer
	, (OD.UnitPrice * Quantity * (1-Discount)) AS Price
	, Discount
FROM [Order Details] OD
	JOIN Orders O
		ON O.OrderID = OD.OrderID
	JOIN Products P
		ON P.ProductID = OD.ProductID
	JOIN Categories C
		ON C.categoryID = P.CategoryID
	JOIN Customers CS
		ON CS.CustomerID = O.CustomerID
ORDER BY Category
COMPUTE SUM((OD.UnitPrice * Quantity * (1-Discount))) BY Category

-- This is similar to the preceding query 
-- but it shows the Average discount per Customer

SELECT CompanyName AS Customer
	, (OD.UnitPrice * Quantity * (1-Discount)) AS Price
	, Discount
FROM [Order Details] OD
	JOIN Orders O
		ON O.OrderID = OD.OrderID
	JOIN Customers CS
		ON CS.CustomerID = O.CustomerID
ORDER BY Customer
COMPUTE AVG(Discount) BY Customer

-- This is a similar query as before 
-- but it shows the Average discount per Category and Product
-- plus the overall average and grand total price

SELECT CategoryName AS Category
	, ProductName AS Product
	, (OD.UnitPrice * Quantity * (1-Discount)) AS Price
	, Discount
FROM [Order Details] OD
	JOIN Orders O
		ON O.OrderID = OD.OrderID
	JOIN Products P
		ON P.ProductID = OD.ProductID
	JOIN Categories C
		ON C.categoryID = P.CategoryID
ORDER BY Category, Product
COMPUTE AVG(Discount) BY Category, Product
COMPUTE AVG(Discount) BY Category
COMPUTE SUM((OD.UnitPrice * Quantity * (1-Discount)))
