/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 12.5, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

SET NOCOUNT ON
GO

-- Declare host variables

DECLARE @ID int, @UnitPrice money

-- Declare the cursor

DECLARE MyProducts CURSOR LOCAL
	FORWARD_ONLY
	FOR
		SELECT ProductID, UnitPrice
		FROM Products

-- Open the cursor

OPEN MyProducts

-- Fetch the first row in the cursor

FETCH NEXT FROM MyProducts
	INTO @ID, @UnitPrice

WHILE @@FETCH_STATUS = 0

-- While the fetch is successful

BEGIN

	-- Update the current product
	
	UPDATE Products
	SET UnitPrice = @UnitPrice * 1.05
	WHERE CURRENT OF MyProducts
	
	-- Fetch next product
	
	FETCH NEXT FROM MyProducts
		INTO @ID, @UnitPrice
		
END

-- Close the cursor

CLOSE MyProducts

-- Deallocate the cursor

DEALLOCATE MyProducts
