/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 12.13, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

SET NOCOUNT ON
GO

BEGIN TRAN

	-- Declare the cursor
	
	DECLARE MyProducts CURSOR
	FORWARD_ONLY READ_ONLY
	FOR
		SELECT ProductID, ProductName
		FROM Products
		WHERE ProductID > 70
		ORDER BY ProductID
	
	-- Open the cursor
	
	OPEN MyProducts
	
	-- Fetch the first row
	
	FETCH NEXT FROM MyProducts
	
	-- Try to update the data
	-- in the current row
	-- gives an error
	-- on a READ_ONLY cursor
	
	UPDATE Products
	SET productname = 'Modified name'
	WHERE CURRENT OF MyProducts
	
	
	-- Close the cursor
	
	CLOSE MyProducts
	
	-- Deallocate the cursor
	
	DEALLOCATE MyProducts

ROLLBACK TRAN
