/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 12.16, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

SET NOCOUNT ON
GO

-- Create a procedure to open
-- a cursor on Categories

CREATE PROCEDURE GetCategories
AS
	DECLARE MyCategories CURSOR STATIC
	FOR
		SELECT CategoryID, CategoryName
		FROM Categories
	
	OPEN MyCategories
	
	-- Shows the number of rows in the cursor
	
	SELECT @@CURSOR_ROWS 'Categories cursor rows after open'
	
	CLOSE MyCategories
	
	DEALLOCATE MyCategories
GO

-- Create a cursor on Products

DECLARE MyProducts CURSOR STATIC
FOR
	SELECT ProductID, ProductName
	FROM Products

OPEN MyProducts

-- Shows the number of rows in the last opened cursor, which is MyProducts

SELECT @@CURSOR_ROWS 'Products cursor rows'

EXEC GetCategories

-- Shows the number of rows in the last opened cursor 
-- in the current connection, which is MyCategories

SELECT @@CURSOR_ROWS 'Categories cursor rows after close and deallocated'

CLOSE MyProducts

DEALLOCATE MyProducts
