/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 12.23, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

SET NOCOUNT ON
GO

ALTER TABLE Customers
ADD CreditLimit money
GO

CREATE PROCEDURE AssignCreditLimit
@ID nvarchar(5)
AS

	-- Write here your own CreditLimit function
	
	   UPDATE Customers
	   SET CreditLimit = 1000
	   WHERE CustomerID = @ID
GO

CREATE TRIGGER isr_Customers
ON Customers
FOR INSERT AS

	SET NOCOUNT ON
	
	DECLARE @ID nvarchar(5)
	
	IF @@ROWCOUNT > 1
	-- Multi row operation
	BEGIN
	
		-- Open a cursor on the Inserted table
		
		DECLARE NewCustomers CURSOR
		FOR 
			SELECT CustomerID
			FROM Inserted
			ORDER BY CustomerID
		
		OPEN NewCustomers
		
		FETCH NEXT FROM NewCustomers
			INTO @ID
		
		WHILE @@FETCH_STATUS = 0
		BEGIN
		
			-- Assign new Credit Limit to every new customer
			
			EXEC AssignCreditLimit @ID
			
			FETCH NEXT FROM NewCustomers
				INTO @ID
		END
		
		-- close the cursor
		
		CLOSE NewCustomers
		DEALLOCATE NewCustomers
	END
		
	ELSE
	-- Single row operation
	BEGIN
		SELECT @ID = CustomerID
		FROM Inserted
		
		IF @ID IS NOT NULL
		
		-- Assign new Credit Limit to the new customer
		
		EXEC AssignCreditLimit @ID
	END
	
GO

-- Test it

INSERT customers (CustomerID, CompanyName)
VALUES ('ZZZZZ', 'New Company')

SELECT CreditLimit
FROM Customers
WHERE CustomerID = 'ZZZZZ'
