/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 13.5, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

BEGIN TRAN Customers

	UPDATE Customers
	SET ContactTitle = 'President'
	WHERE CustomerID = 'AROUT'
	
	SELECT @@TRANCOUNT 'Start Customers Transaction'
	
	BEGIN TRAN Products
	
		UPDATE Products
		SET UnitPrice = UnitPrice * 1.1
		WHERE CategoryID = 3
		
		SELECT @@TRANCOUNT 'Start Products Transaction'
		
		BEGIN TRAN Regions
		
			INSERT Region
			VALUES (5, 'Europe')
			
			SELECT @@TRANCOUNT 'Start Regions Transaction'
		
		COMMIT TRAN Regions
		
		SELECT @@TRANCOUNT 'Commit Regions Transaction'
		
		BEGIN TRAN Orders
		
			UPDATE Orders
			SET ShippedDate = CONVERT(VARCHAR(10), Getdate(), 120)
			WHERE OrderID = 10500
			
			SELECT @@TRANCOUNT 'Start Orders Transaction'
		
		COMMIT TRAN Orders
		
		SELECT @@TRANCOUNT 'Commit Orders Transaction'
	
	COMMIT TRAN Products
	
	SELECT @@TRANCOUNT 'Commit Products Transaction'

COMMIT TRAN Customers

SELECT @@TRANCOUNT 'Commit Customers Transaction'
