/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 13.6, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

BEGIN TRAN Customers

	UPDATE Customers
	SET ContactTitle = 'President'
	WHERE CustomerID = 'AROUT'
	
	SELECT @@TRANCOUNT 'Start Customers Transaction'
	
	BEGIN TRAN Products
	
		UPDATE Products
		SET UnitPrice = UnitPrice * 1.1
		WHERE CategoryID = 3
		
		SELECT @@TRANCOUNT 'Start Products Transaction'
		
		BEGIN TRAN Orders
		
			UPDATE Orders
			SET ShippedDate = CONVERT(VARCHAR(10), Getdate(), 120)
			WHERE OrderID = 10500
			
			SELECT @@TRANCOUNT 'Start Orders Transaction'
			
		COMMIT TRAN Orders
		
		SELECT @@TRANCOUNT 'Commit Orders Transaction'
		
		-- Note: the following statement produces an error,
		-- because the specified transaction name is invalid
		
	ROLLBACK TRAN Products
	
	SELECT @@TRANCOUNT 'Rollback Products Transaction'

ROLLBACK TRAN Customers

SELECT @@TRANCOUNT 'Rollback Customers Transaction'
