/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 13.7, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

BEGIN TRAN NewOrder

	-- Insert a new Order
	
	DECLARE @ID int
	
	INSERT Orders (CustomerID, OrderDate)
	VALUES ('BOTTM', '2000-11-23')
	
	-- Obtain the newly inserted OrderID
	
	SET @ID = @@IDENTITY
	
	-- Insert [Order details] data
	
	INSERT [Order Details]
		(OrderID, ProductID, UnitPrice, Quantity, Discount)
	SELECT @ID, 23, 9, 12, 0.10
	
	INSERT [Order Details]
		(OrderID, ProductID, UnitPrice, Quantity, Discount)
	SELECT @ID, 18, 62.5, 5, 0.05
	
	INSERT [Order Details]
		(OrderID, ProductID, UnitPrice, Quantity, Discount)
	SELECT @ID, 32, 32, 5, 0.05
	
	INSERT [Order Details]
		(OrderID, ProductID, UnitPrice, Quantity, Discount)
	SELECT @ID, 9, 97, 4, 0.10
	
	-- try the discount
	
	-- Create a Savepoint
	
	SAVE TRAN Discount
	
		-- Increase the discount to
		-- products where Quantity >= 5
		
		UPDATE [Order Details]
		SET Discount = Discount + 0.1
		WHERE OrderID = @ID
			AND QUANTITY >= 5
		
		-- Check the total price, after the extra discount, to see if
		-- this order qualifies for this discount.
		
		IF (
			SELECT SUM(Quantity * UnitPrice * (1-Discount))
			FROM [Order Details]
			WHERE OrderID = @ID
			) < 500
			
			-- Does not qualify, rollback the discount
				
			ROLLBACK TRAN Discount
	
	-- Commit the transaction, inserting the order permanently
	
COMMIT TRAN NewOrder
