/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 13.17, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

-- Use the SERIALIZABLE or HOLDLOCK locking hints to prevent
-- inconsistent analysis due to Phantom Reads

DECLARE @ID int

BEGIN TRANSACTION

	SELECT @ID = MAX(RegionID)
	FROM Region (SERIALIZABLE)
	
	INSERT Region
		(RegionID, RegionDescription)
	SELECT @ID + 1, 'Europe Union'

COMMIT TRANSACTION
GO

-- Use the SERIALIZABLE Isolation level to prevent
-- inconsistent analysis due to Phantom Reads in a long running process

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE
GO

BEGIN TRANSACTION

	-- Your queries

COMMIT TRANSACTION
