/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 13.18, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

BEGIN TRAN

	DECLARE @UP money
	
	-- Read and lock the data to prevent updates
	
	SELECT @UP = AVG(UnitPrice)
	FROM [Order Details] (REPEATABLEREAD)
	WHERE ProductID = 37
	
	-- Update the Product 37
	
	UPDATE Products
	SET UnitPrice = @UP
	WHERE ProductID = 37
	
	-- List locks server wide
	
	EXECUTE sp_lock
	
	-- List locks for this connection only
	
	EXECUTE sp_lock @@SPID
	
	-- Cancel changes
	
ROLLBACK TRAN
