/***************************************************
** Microsoft SQL Server 2000 Programming by Example
** ISBN 0-7897-2449-9
** Carlos Eduardo Rojas and Fernando G. Guerrero
** Copyright 2001 by QUE Corporation,
** Source code. Listing 14.11, Version 1.0, 2001-04-04
****************************************************/


USE Northwind
GO

PRINT CHAR(10)
	+ 'Exporting the Products Table in widenative mode'
	+ CHAR(10)

EXECUTE master.dbo.xp_cmdshell 'bcp northwind.dbo.products out c:\temp\products.txt -S MSSQLFGG\S2K -T -N'
GO

PRINT CHAR(10)
	+ 'Creating the NewProducts table '
	+ 'with the same structure as '
	+ CHAR(10)
	+ 'the Products table but empty'
	+ CHAR(10)

SELECT *
INTO NewProducts
FROM Products
WHERE ProductID = -1
GO

PRINT CHAR(10)
	+ 'Checking the NewProducts table'
	+ CHAR(10)

SELECT COUNT(*)
FROM NewProducts
GO

PRINT CHAR(10)
	+ 'Importing the Products.txt file into the NewProducts Table'
	+ CHAR(10)

BULK INSERT NewProducts FROM 'c:\temp\Products.txt'
WITH
	(
		DATAFILETYPE = 'widenative'
	)
GO

PRINT CHAR(10)
	+ 'Checking the NewProducts table'
	+ CHAR(10)

SELECT COUNT(*) AS NRows
FROM NewProducts
GO
